##// END OF EJS Templates
Merge branch 'pi4Proposal' into masterGV
vidal -
r714:3d432162ca05 Fusion
parent child
Show More
@@ -1,332 +1,332
1 #
1 #
2 # Setup RPi2/3 config and cmdline
2 # Setup RPi2/3/4 config and cmdline
3 #
3 #
4
4
5 # Load utility functions
5 # Load utility functions
6 . ./functions.sh
6 . ./functions.sh
7
7
8 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
8 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
9 # Install boot binaries from local directory
9 # Install boot binaries from local directory
10 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
10 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
11 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
11 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
14 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
14 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
15 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
15 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
16 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
16 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
17 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4cd.dat "${BOOT_DIR}"/fixup4cd.dat
17 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4cd.dat "${BOOT_DIR}"/fixup4cd.dat
18 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4.dat "${BOOT_DIR}"/fixup4.dat
18 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4.dat "${BOOT_DIR}"/fixup4.dat
19 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4db.dat "${BOOT_DIR}"/fixup4db.dat
19 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4db.dat "${BOOT_DIR}"/fixup4db.dat
20 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4x.dat "${BOOT_DIR}"/fixup4x.dat
20 cp "${RPI_FIRMWARE_DIR}"/boot/fixup4x.dat "${BOOT_DIR}"/fixup4x.dat
21 cp "${RPI_FIRMWARE_DIR}"/boot/start4cd.elf "${BOOT_DIR}"/start4cd.elf
21 cp "${RPI_FIRMWARE_DIR}"/boot/start4cd.elf "${BOOT_DIR}"/start4cd.elf
22 cp "${RPI_FIRMWARE_DIR}"/boot/start4db.elf "${BOOT_DIR}"/start4db.elf
22 cp "${RPI_FIRMWARE_DIR}"/boot/start4db.elf "${BOOT_DIR}"/start4db.elf
23 cp "${RPI_FIRMWARE_DIR}"/boot/start4.elf "${BOOT_DIR}"/start4x.elf
23 cp "${RPI_FIRMWARE_DIR}"/boot/start4.elf "${BOOT_DIR}"/start4x.elf
24 cp "${RPI_FIRMWARE_DIR}"/boot/start4x.elf "${BOOT_DIR}"/start4x.elf
24 cp "${RPI_FIRMWARE_DIR}"/boot/start4x.elf "${BOOT_DIR}"/start4x.elf
25 else
25 else
26 # Create temporary directory for boot binaries
26 # Create temporary directory for boot binaries
27 temp_dir=$(as_nobody mktemp -d)
27 temp_dir=$(as_nobody mktemp -d)
28
28
29 # Install latest boot binaries from raspberry/firmware github
29 # Install latest boot binaries from raspberry/firmware github
30 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
30 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
31 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
31 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
32 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
32 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
33 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
33 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
34 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
34 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
35 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
35 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
36 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
36 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
37 as_nobody wget -q -O "${temp_dir}/fixup4cd.dat" "${FIRMWARE_URL}/fixup4cd.dat"
37 as_nobody wget -q -O "${temp_dir}/fixup4cd.dat" "${FIRMWARE_URL}/fixup4cd.dat"
38 as_nobody wget -q -O "${temp_dir}/fixup4.dat" "${FIRMWARE_URL}/fixup4.dat"
38 as_nobody wget -q -O "${temp_dir}/fixup4.dat" "${FIRMWARE_URL}/fixup4.dat"
39 as_nobody wget -q -O "${temp_dir}/fixup4db.dat" "${FIRMWARE_URL}/fixup4db.dat"
39 as_nobody wget -q -O "${temp_dir}/fixup4db.dat" "${FIRMWARE_URL}/fixup4db.dat"
40 as_nobody wget -q -O "${temp_dir}/fixup4x.dat" "${FIRMWARE_URL}/fixup4x.dat"
40 as_nobody wget -q -O "${temp_dir}/fixup4x.dat" "${FIRMWARE_URL}/fixup4x.dat"
41 as_nobody wget -q -O "${temp_dir}/start4cd.elf" "${FIRMWARE_URL}/start4cd.elf"
41 as_nobody wget -q -O "${temp_dir}/start4cd.elf" "${FIRMWARE_URL}/start4cd.elf"
42 as_nobody wget -q -O "${temp_dir}/start4db.elf" "${FIRMWARE_URL}/start4db.elf"
42 as_nobody wget -q -O "${temp_dir}/start4db.elf" "${FIRMWARE_URL}/start4db.elf"
43 as_nobody wget -q -O "${temp_dir}/start4x.elf" "${FIRMWARE_URL}/start4x.elf"
43 as_nobody wget -q -O "${temp_dir}/start4x.elf" "${FIRMWARE_URL}/start4x.elf"
44 as_nobody wget -q -O "${temp_dir}/start4x.elf" "${FIRMWARE_URL}/start4x.elf"
44 as_nobody wget -q -O "${temp_dir}/start4x.elf" "${FIRMWARE_URL}/start4x.elf"
45
45
46 # Move downloaded boot binaries
46 # Move downloaded boot binaries
47 mv "${temp_dir}/"* "${BOOT_DIR}/"
47 mv "${temp_dir}/"* "${BOOT_DIR}/"
48
48
49 # Remove temporary directory for boot binaries
49 # Remove temporary directory for boot binaries
50 rm -fr "${temp_dir}"
50 rm -fr "${temp_dir}"
51
51
52 # Set permissions of the boot binaries
52 # Set permissions of the boot binaries
53 chown -R root:root "${BOOT_DIR}"
53 chown -R root:root "${BOOT_DIR}"
54 chmod -R 600 "${BOOT_DIR}"
54 chmod -R 600 "${BOOT_DIR}"
55 fi
55 fi
56
56
57 # Setup firmware boot cmdline
57 # Setup firmware boot cmdline
58 if [ "$ENABLE_USBBOOT" = true ] ; then
58 if [ "$ENABLE_USBBOOT" = true ] ; then
59 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
59 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
60 else
60 else
61 if [ "$ENABLE_SPLITFS" = true ] ; then
61 if [ "$ENABLE_SPLITFS" = true ] ; then
62 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
62 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
63 else
63 else
64 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
64 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
65 fi
65 fi
66 fi
66 fi
67
67
68 # Add encrypted root partition to cmdline.txt
68 # Add encrypted root partition to cmdline.txt
69 if [ "$ENABLE_CRYPTFS" = true ] ; then
69 if [ "$ENABLE_CRYPTFS" = true ] ; then
70 if [ "$ENABLE_SPLITFS" = true ] ; then
70 if [ "$ENABLE_SPLITFS" = true ] ; then
71 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
71 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
72 else
72 else
73 if [ "$ENABLE_USBBOOT" = true ] ; then
73 if [ "$ENABLE_USBBOOT" = true ] ; then
74 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
74 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
75 else
75 else
76 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
76 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
77 fi
77 fi
78 fi
78 fi
79 fi
79 fi
80
80
81 # Enable Kernel messages on standard output
81 # Enable Kernel messages on standard output
82 if [ "$ENABLE_PRINTK" = true ] ; then
82 if [ "$ENABLE_PRINTK" = true ] ; then
83 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
83 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
84 fi
84 fi
85
85
86 # Enable Kernel messages on standard output
86 # Enable Kernel messages on standard output
87 if [ "$KERNEL_SECURITY" = true ] ; then
87 if [ "$KERNEL_SECURITY" = true ] ; then
88 install_readonly files/sysctl.d/84-rpi-ASLR.conf "${ETC_DIR}/sysctl.d/84-rpi-ASLR.conf"
88 install_readonly files/sysctl.d/84-rpi-ASLR.conf "${ETC_DIR}/sysctl.d/84-rpi-ASLR.conf"
89 fi
89 fi
90
90
91 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
91 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
92 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
92 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
93
93
94 # Remove IPv6 networking support
94 # Remove IPv6 networking support
95 if [ "$ENABLE_IPV6" = false ] ; then
95 if [ "$ENABLE_IPV6" = false ] ; then
96 CMDLINE="${CMDLINE} ipv6.disable=1"
96 CMDLINE="${CMDLINE} ipv6.disable=1"
97 fi
97 fi
98
98
99 # Automatically assign predictable network interface names
99 # Automatically assign predictable network interface names
100 if [ "$ENABLE_IFNAMES" = false ] ; then
100 if [ "$ENABLE_IFNAMES" = false ] ; then
101 CMDLINE="${CMDLINE} net.ifnames=0"
101 CMDLINE="${CMDLINE} net.ifnames=0"
102 else
102 else
103 CMDLINE="${CMDLINE} net.ifnames=1"
103 CMDLINE="${CMDLINE} net.ifnames=1"
104 fi
104 fi
105
105
106 # Disable Raspberry Pi console logo
106 # Disable Raspberry Pi console logo
107 if [ "$ENABLE_LOGO" = false ] ; then
107 if [ "$ENABLE_LOGO" = false ] ; then
108 CMDLINE="${CMDLINE} logo.nologo"
108 CMDLINE="${CMDLINE} logo.nologo"
109 fi
109 fi
110
110
111 # Strictly limit verbosity of boot up console messages
111 # Strictly limit verbosity of boot up console messages
112 if [ "$ENABLE_SILENT_BOOT" = true ] ; then
112 if [ "$ENABLE_SILENT_BOOT" = true ] ; then
113 CMDLINE="${CMDLINE} quiet loglevel=0 rd.systemd.show_status=auto rd.udev.log_priority=0"
113 CMDLINE="${CMDLINE} quiet loglevel=0 rd.systemd.show_status=auto rd.udev.log_priority=0"
114 fi
114 fi
115
115
116 # Install firmware config
116 # Install firmware config
117 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
117 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
118
118
119 # Disable Raspberry Pi console logo
119 # Disable Raspberry Pi console logo
120 if [ "$ENABLE_SLASH" = false ] ; then
120 if [ "$ENABLE_SLASH" = false ] ; then
121 echo "disable_splash=1" >> "${BOOT_DIR}/config.txt"
121 echo "disable_splash=1" >> "${BOOT_DIR}/config.txt"
122 fi
122 fi
123
123
124 # Locks CPU frequency at maximum
124 # Locks CPU frequency at maximum
125 if [ "$ENABLE_TURBO" = true ] ; then
125 if [ "$ENABLE_TURBO" = true ] ; then
126 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
126 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
127 # helps to avoid sdcard corruption when force_turbo is enabled.
127 # helps to avoid sdcard corruption when force_turbo is enabled.
128 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
128 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
129 fi
129 fi
130
130
131 <<<<<<< HEAD
131 <<<<<<< HEAD
132 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
132 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
133 =======
133 =======
134 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
134 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
135 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ]; then
135 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ]; then
136
136
137 # Bluetooth enabled
137 # Bluetooth enabled
138 if [ "$ENABLE_BLUETOOTH" = true ] ; then
138 if [ "$ENABLE_BLUETOOTH" = true ] ; then
139 # Create temporary directory for Bluetooth sources
139 # Create temporary directory for Bluetooth sources
140 temp_dir=$(as_nobody mktemp -d)
140 temp_dir=$(as_nobody mktemp -d)
141
141
142 # Fetch Bluetooth sources
142 # Fetch Bluetooth sources
143 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
143 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
144
144
145 # Copy downloaded sources
145 # Copy downloaded sources
146 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
146 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
147
147
148 # Set permissions
148 # Set permissions
149 chown -R root:root "${R}/tmp/pi-bluetooth"
149 chown -R root:root "${R}/tmp/pi-bluetooth"
150
150
151 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
151 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
152 wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
152 wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
153 wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://raw.githubusercontent.com/RPi-Distro/bluez-firmware/master/broadcom/BCM43430A1.hcd
153 wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://raw.githubusercontent.com/RPi-Distro/bluez-firmware/master/broadcom/BCM43430A1.hcd
154
154
155 # Install tools
155 # Install tools
156 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
156 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
157 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
157 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
158
158
159 # make scripts executable
159 # make scripts executable
160 chmod +x "${R}/usr/bin/bthelper"
160 chmod +x "${R}/usr/bin/bthelper"
161 chmod +x "${R}/usr/bin/btuart"
161 chmod +x "${R}/usr/bin/btuart"
162
162
163 # Install bluetooth udev rule
163 # Install bluetooth udev rule
164 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
164 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
165
165
166 # Install Firmware Flash file and apropiate licence
166 # Install Firmware Flash file and apropiate licence
167 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
167 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
168 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
168 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
169 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/BCM43430A1.hcd"
169 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/BCM43430A1.hcd"
170 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
170 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
171 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
171 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
172
172
173 # Remove temporary directories
173 # Remove temporary directories
174 rm -fr "${temp_dir}"
174 rm -fr "${temp_dir}"
175 rm -fr "${R}"/tmp/pi-bluetooth
175 rm -fr "${R}"/tmp/pi-bluetooth
176
176
177 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
177 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
178 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
178 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
179 # set overlay to swap ttyAMA0 and ttyS0
179 # set overlay to swap ttyAMA0 and ttyS0
180 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
180 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
181
181
182 if [ "$ENABLE_TURBO" = false ] ; then
182 if [ "$ENABLE_TURBO" = false ] ; then
183 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
183 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
184 fi
184 fi
185
185
186 fi
186 fi
187
187
188 # Activate services
188 # Activate services
189 chroot_exec systemctl enable pi-bluetooth.hciuart.service
189 chroot_exec systemctl enable pi-bluetooth.hciuart.service
190
190
191 else # if ENABLE_BLUETOOTH = false
191 else # if ENABLE_BLUETOOTH = false
192 # set overlay to disable bluetooth
192 # set overlay to disable bluetooth
193 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
193 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
194 fi # ENABLE_BLUETOOTH end
194 fi # ENABLE_BLUETOOTH end
195 fi
195 fi
196
196
197 # may need sudo systemctl disable hciuart
197 # may need sudo systemctl disable hciuart
198 if [ "$ENABLE_CONSOLE" = true ] ; then
198 if [ "$ENABLE_CONSOLE" = true ] ; then
199 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
199 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
200 # add string to cmdline
200 # add string to cmdline
201 CMDLINE="${CMDLINE} console=serial0,115200"
201 CMDLINE="${CMDLINE} console=serial0,115200"
202
202
203 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]|| [ "$RPI_MODEL" = 0 ]; then
203 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]|| [ "$RPI_MODEL" = 0 ]; then
204 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
204 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
205 if [ "$ENABLE_TURBO" = false ] ; then
205 if [ "$ENABLE_TURBO" = false ] ; then
206 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
206 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
207 fi
207 fi
208 fi
208 fi
209
209
210 # Enable serial console systemd style
210 # Enable serial console systemd style
211 chroot_exec systemctl enable serial-getty@serial0.service
211 chroot_exec systemctl enable serial-getty@serial0.service
212 else
212 else
213 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
213 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
214 fi
214 fi
215
215
216 # Disable dphys-swapfile service. Will get enabled on first boot
216 # Disable dphys-swapfile service. Will get enabled on first boot
217 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
217 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
218 chroot_exec systemctl disable dphys-swapfile
218 chroot_exec systemctl disable dphys-swapfile
219 fi
219 fi
220
220
221 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
221 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
222 # Create temporary directory for systemd-swap sources
222 # Create temporary directory for systemd-swap sources
223 temp_dir=$(as_nobody mktemp -d)
223 temp_dir=$(as_nobody mktemp -d)
224
224
225 # Fetch systemd-swap sources
225 # Fetch systemd-swap sources
226 as_nobody git -C "${temp_dir}" clone "${SYSTEMDSWAP_URL}"
226 as_nobody git -C "${temp_dir}" clone "${SYSTEMDSWAP_URL}"
227
227
228 # Copy downloaded systemd-swap sources
228 # Copy downloaded systemd-swap sources
229 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
229 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
230
230
231 # Change into downloaded src dir
231 # Change into downloaded src dir
232 cd "${R}/tmp/systemd-swap" || exit
232 cd "${R}/tmp/systemd-swap" || exit
233 <<<<<<< HEAD
233 <<<<<<< HEAD
234
234
235 =======
235 =======
236 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
236 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
237
237
238 # Get Verion
238 # Get Verion
239 VERSION=$(git tag | tail -n 1)
239 VERSION=$(git tag | tail -n 1)
240 #sed -i "s/DEB_NAME=.*/DEB_NAME=systemd-swap_all/g" "${R}/tmp/systemd-swap/package.sh"
240 #sed -i "s/DEB_NAME=.*/DEB_NAME=systemd-swap_all/g" "${R}/tmp/systemd-swap/package.sh"
241
241
242 # Build package
242 # Build package
243 bash ./package.sh debian
243 bash ./package.sh debian
244
244
245 # Change back into script root dir
245 # Change back into script root dir
246 cd "${WORKDIR}" || exit
246 cd "${WORKDIR}" || exit
247
247
248 # Set permissions of the systemd-swap sources
248 # Set permissions of the systemd-swap sources
249 chown -R root:root "${R}/tmp/systemd-swap"
249 chown -R root:root "${R}/tmp/systemd-swap"
250
250
251 # Install package - IMPROVE AND MAKE IT POSSIBLE WITHOUT VERSION NR.
251 # Install package - IMPROVE AND MAKE IT POSSIBLE WITHOUT VERSION NR.
252 <<<<<<< HEAD
252 <<<<<<< HEAD
253 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_4.0.1_any.deb
253 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_4.0.1_any.deb
254 =======
254 =======
255 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
255 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
256 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_"$VERSION"_all.deb
256 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_"$VERSION"_all.deb
257
257
258 # Enable service
258 # Enable service
259 chroot_exec systemctl enable systemd-swap
259 chroot_exec systemctl enable systemd-swap
260
260
261 # Remove temporary directory for systemd-swap sources
261 # Remove temporary directory for systemd-swap sources
262 rm -fr "${temp_dir}"
262 rm -fr "${temp_dir}"
263 else
263 else
264 # Enable ZSWAP in cmdline if systemd-swap is not used
264 # Enable ZSWAP in cmdline if systemd-swap is not used
265 if [ "$KERNEL_ZSWAP" = true ] ; then
265 if [ "$KERNEL_ZSWAP" = true ] ; then
266 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
266 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
267 fi
267 fi
268 fi
268 fi
269 if [ "$KERNEL_SECURITY" = true ] ; then
269 if [ "$KERNEL_SECURITY" = true ] ; then
270 CMDLINE="${CMDLINE} apparmor=1 security=apparmor"
270 CMDLINE="${CMDLINE} apparmor=1 security=apparmor"
271 fi
271 fi
272
272
273 # Install firmware boot cmdline
273 # Install firmware boot cmdline
274 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
274 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
275
275
276 # Setup minimal GPU memory allocation size: 16MB (no X)
276 # Setup minimal GPU memory allocation size: 16MB (no X)
277 if [ "$ENABLE_MINGPU" = true ] ; then
277 if [ "$ENABLE_MINGPU" = true ] ; then
278 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
278 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
279 fi
279 fi
280
280
281 # Setup boot with initramfs
281 # Setup boot with initramfs
282 if [ "$ENABLE_INITRAMFS" = true ] ; then
282 if [ "$ENABLE_INITRAMFS" = true ] ; then
283 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
283 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
284 fi
284 fi
285
285
286 # Create firmware configuration and cmdline symlinks
286 # Create firmware configuration and cmdline symlinks
287 ln -sf firmware/config.txt "${R}/boot/config.txt"
287 ln -sf firmware/config.txt "${R}/boot/config.txt"
288 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
288 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
289
289
290 # Install and setup kernel modules to load at boot
290 # Install and setup kernel modules to load at boot
291 mkdir -p "${LIB_DIR}/modules-load.d/"
291 mkdir -p "${LIB_DIR}/modules-load.d/"
292 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
292 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
293
293
294 # Load hardware random module at boot
294 # Load hardware random module at boot
295 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
295 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
296 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
296 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
297 fi
297 fi
298
298
299 # Load sound module at boot
299 # Load sound module at boot
300 if [ "$ENABLE_SOUND" = true ] ; then
300 if [ "$ENABLE_SOUND" = true ] ; then
301 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
301 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
302 else
302 else
303 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
303 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
304 fi
304 fi
305
305
306 # Enable I2C interface
306 # Enable I2C interface
307 if [ "$ENABLE_I2C" = true ] ; then
307 if [ "$ENABLE_I2C" = true ] ; then
308 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
308 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
309 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
309 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
310 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
310 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
311 fi
311 fi
312
312
313 # Enable SPI interface
313 # Enable SPI interface
314 if [ "$ENABLE_SPI" = true ] ; then
314 if [ "$ENABLE_SPI" = true ] ; then
315 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
315 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
316 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
316 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
317 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
317 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
318 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
318 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
319 fi
319 fi
320 fi
320 fi
321
321
322 # Disable RPi2/3 under-voltage warnings
322 # Disable RPi2/3 under-voltage warnings
323 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
323 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
324 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
324 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
325 fi
325 fi
326
326
327 # Install kernel modules blacklist
327 # Install kernel modules blacklist
328 mkdir -p "${ETC_DIR}/modprobe.d/"
328 mkdir -p "${ETC_DIR}/modprobe.d/"
329 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
329 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
330
330
331 # Install sysctl.d configuration files
331 # Install sysctl.d configuration files
332 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
332 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,936 +1,936
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47 if [ $RELEASE = "bullseye" ] ; then
47 if [ $RELEASE = "bullseye" ] ; then
48 RELEASE=testing
48 RELEASE=testing
49 fi
49 fi
50
50
51 # Kernel Branch
51 # Kernel Branch
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53
53
54 # URLs
54 # URLs
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64
64
65 # Kernel deb packages for 32bit kernel
65 # Kernel deb packages for 32bit kernel
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 <<<<<<< HEAD
69 <<<<<<< HEAD
70 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
70 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
71 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
71 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
72 # Default precompiled 64bit kernel
72 # Default precompiled 64bit kernel
73 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
73 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
74 =======
74 =======
75 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
75 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.80.20191022/bcmrpi3-kernel-bis-4.19.80.20191022.tar.xz}
76 # Default precompiled 64bit kernel
76 # Default precompiled 64bit kernel
77 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
77 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
78 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
78 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.80.20191022/bcmrpi3-kernel-4.19.80.20191022.tar.xz}
79 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
79 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
80 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
80 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
81 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
81 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
82 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
82 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz}
83 # Generic
83 # Generic
84 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
84 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
85 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
85 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
86 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
86 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
87 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
87 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
88
88
89 # Build directories
89 # Build directories
90 WORKDIR=$(pwd)
90 WORKDIR=$(pwd)
91 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
91 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
92 BUILDDIR="${BASEDIR}/build"
92 BUILDDIR="${BASEDIR}/build"
93
93
94 # Chroot directories
94 # Chroot directories
95 R="${BUILDDIR}/chroot"
95 R="${BUILDDIR}/chroot"
96 ETC_DIR="${R}/etc"
96 ETC_DIR="${R}/etc"
97 LIB_DIR="${R}/lib"
97 LIB_DIR="${R}/lib"
98 BOOT_DIR="${R}/boot/firmware"
98 BOOT_DIR="${R}/boot/firmware"
99 KERNEL_DIR="${R}/usr/src/linux"
99 KERNEL_DIR="${R}/usr/src/linux"
100 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
100 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
101 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
101 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
102
102
103 # Firmware directory: Blank if download from github
103 # Firmware directory: Blank if download from github
104 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
104 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
105
105
106 # General settings
106 # General settings
107 SET_ARCH=${SET_ARCH:=32}
107 SET_ARCH=${SET_ARCH:=32}
108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
108 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 PASSWORD=${PASSWORD:=raspberry}
109 PASSWORD=${PASSWORD:=raspberry}
110 USER_PASSWORD=${USER_PASSWORD:=raspberry}
110 USER_PASSWORD=${USER_PASSWORD:=raspberry}
111 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
111 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
112 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
112 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
113 EXPANDROOT=${EXPANDROOT:=true}
113 EXPANDROOT=${EXPANDROOT:=true}
114 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
114 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
115
115
116 # Keyboard settings
116 # Keyboard settings
117 XKB_MODEL=${XKB_MODEL:=""}
117 XKB_MODEL=${XKB_MODEL:=""}
118 XKB_LAYOUT=${XKB_LAYOUT:=""}
118 XKB_LAYOUT=${XKB_LAYOUT:=""}
119 XKB_VARIANT=${XKB_VARIANT:=""}
119 XKB_VARIANT=${XKB_VARIANT:=""}
120 XKB_OPTIONS=${XKB_OPTIONS:=""}
120 XKB_OPTIONS=${XKB_OPTIONS:=""}
121
121
122 # Network settings (DHCP)
122 # Network settings (DHCP)
123 ENABLE_DHCP=${ENABLE_DHCP:=true}
123 ENABLE_DHCP=${ENABLE_DHCP:=true}
124
124
125 # Network settings (static)
125 # Network settings (static)
126 NET_ADDRESS=${NET_ADDRESS:=""}
126 NET_ADDRESS=${NET_ADDRESS:=""}
127 NET_GATEWAY=${NET_GATEWAY:=""}
127 NET_GATEWAY=${NET_GATEWAY:=""}
128 NET_DNS_1=${NET_DNS_1:=""}
128 NET_DNS_1=${NET_DNS_1:=""}
129 NET_DNS_2=${NET_DNS_2:=""}
129 NET_DNS_2=${NET_DNS_2:=""}
130 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
130 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
131 NET_NTP_1=${NET_NTP_1:=""}
131 NET_NTP_1=${NET_NTP_1:=""}
132 NET_NTP_2=${NET_NTP_2:=""}
132 NET_NTP_2=${NET_NTP_2:=""}
133
133
134 # APT settings
134 # APT settings
135 APT_PROXY=${APT_PROXY:=""}
135 APT_PROXY=${APT_PROXY:=""}
136 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
136 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
137 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
137 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
138
138
139 # Feature settings
139 # Feature settings
140 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
140 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
141 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
141 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
142 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
142 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
143 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
143 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
144 ENABLE_I2C=${ENABLE_I2C:=false}
144 ENABLE_I2C=${ENABLE_I2C:=false}
145 ENABLE_SPI=${ENABLE_SPI:=false}
145 ENABLE_SPI=${ENABLE_SPI:=false}
146 ENABLE_IPV6=${ENABLE_IPV6:=true}
146 ENABLE_IPV6=${ENABLE_IPV6:=true}
147 ENABLE_SSHD=${ENABLE_SSHD:=true}
147 ENABLE_SSHD=${ENABLE_SSHD:=true}
148 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
148 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
149 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
149 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
150 ENABLE_SOUND=${ENABLE_SOUND:=true}
150 ENABLE_SOUND=${ENABLE_SOUND:=true}
151 ENABLE_DBUS=${ENABLE_DBUS:=true}
151 ENABLE_DBUS=${ENABLE_DBUS:=true}
152 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
152 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
153 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
153 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
154 ENABLE_XORG=${ENABLE_XORG:=false}
154 ENABLE_XORG=${ENABLE_XORG:=false}
155 ENABLE_WM=${ENABLE_WM:=""}
155 ENABLE_WM=${ENABLE_WM:=""}
156 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
156 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
157 ENABLE_USER=${ENABLE_USER:=true}
157 ENABLE_USER=${ENABLE_USER:=true}
158 USER_NAME=${USER_NAME:="pi"}
158 USER_NAME=${USER_NAME:="pi"}
159 ENABLE_ROOT=${ENABLE_ROOT:=false}
159 ENABLE_ROOT=${ENABLE_ROOT:=false}
160 ENABLE_QEMU=${ENABLE_QEMU:=false}
160 ENABLE_QEMU=${ENABLE_QEMU:=false}
161 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
161 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
162
162
163 # SSH settings
163 # SSH settings
164 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
164 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
165 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
165 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
166 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
166 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
167 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
167 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
168 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
168 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
169
169
170 # Advanced settings
170 # Advanced settings
171 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
171 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
172 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
172 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
173 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
173 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
174 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
174 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
175 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
175 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
176 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
176 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
177 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
177 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
178 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
178 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
179 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
179 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
180 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
180 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
181 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
181 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
182 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
182 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
183 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
183 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
184 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
184 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
185 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
185 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
186 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
186 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
187 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
187 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
188 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
188 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
189 ENABLE_LOGO=${ENABLE_LOGO:=true}
189 ENABLE_LOGO=${ENABLE_LOGO:=true}
190 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
190 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
191 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
191 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
192
192
193 # Kernel compilation settings
193 # Kernel compilation settings
194 BUILD_KERNEL=${BUILD_KERNEL:=true}
194 BUILD_KERNEL=${BUILD_KERNEL:=true}
195 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
195 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
196 KERNEL_THREADS=${KERNEL_THREADS:=1}
196 KERNEL_THREADS=${KERNEL_THREADS:=1}
197 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
197 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
198 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
198 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
199 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
199 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
200 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
200 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
201 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
201 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
202 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
202 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
203 KERNEL_VIRT=${KERNEL_VIRT:=false}
203 KERNEL_VIRT=${KERNEL_VIRT:=false}
204 KERNEL_BPF=${KERNEL_BPF:=false}
204 KERNEL_BPF=${KERNEL_BPF:=false}
205 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
205 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
206 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
206 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
207 KERNEL_NF=${KERNEL_NF:=false}
207 KERNEL_NF=${KERNEL_NF:=false}
208 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
208 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
209 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
209 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
210 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
210 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
211 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
211 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
212
212
213 # Kernel compilation from source directory settings
213 # Kernel compilation from source directory settings
214 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
214 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
215 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
215 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
216 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
216 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
217 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
217 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
218
218
219 # Reduce disk usage settings
219 # Reduce disk usage settings
220 REDUCE_APT=${REDUCE_APT:=true}
220 REDUCE_APT=${REDUCE_APT:=true}
221 REDUCE_DOC=${REDUCE_DOC:=true}
221 REDUCE_DOC=${REDUCE_DOC:=true}
222 REDUCE_MAN=${REDUCE_MAN:=true}
222 REDUCE_MAN=${REDUCE_MAN:=true}
223 REDUCE_VIM=${REDUCE_VIM:=false}
223 REDUCE_VIM=${REDUCE_VIM:=false}
224 REDUCE_BASH=${REDUCE_BASH:=false}
224 REDUCE_BASH=${REDUCE_BASH:=false}
225 REDUCE_HWDB=${REDUCE_HWDB:=true}
225 REDUCE_HWDB=${REDUCE_HWDB:=true}
226 REDUCE_SSHD=${REDUCE_SSHD:=true}
226 REDUCE_SSHD=${REDUCE_SSHD:=true}
227 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
227 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
228
228
229 # Encrypted filesystem settings
229 # Encrypted filesystem settings
230 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
230 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
231 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
231 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
232 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
232 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
233 <<<<<<< HEAD
233 <<<<<<< HEAD
234 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
234 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
235 =======
235 =======
236 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
236 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
238 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
238 CRYPTFS_HASH=${CRYPTFS_HASH:="sha512"}
239 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
240 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
240 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
241 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
241 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
242 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
242 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
243 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
243 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
244
244
245 # Chroot scripts directory
245 # Chroot scripts directory
246 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
246 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
247
247
248 # Packages required in the chroot build environment
248 # Packages required in the chroot build environment
249 APT_INCLUDES=${APT_INCLUDES:=""}
249 APT_INCLUDES=${APT_INCLUDES:=""}
250 <<<<<<< HEAD
250 <<<<<<< HEAD
251 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
251 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
252 =======
252 =======
253 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
253 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
254 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
254 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
255
255
256 # Packages to exclude from chroot build environment
256 # Packages to exclude from chroot build environment
257 APT_EXCLUDES=${APT_EXCLUDES:=""}
257 APT_EXCLUDES=${APT_EXCLUDES:=""}
258
258
259 # Packages required for bootstrapping
259 # Packages required for bootstrapping
260 <<<<<<< HEAD
260 <<<<<<< HEAD
261 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
261 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
262 =======
262 =======
263 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
263 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
264 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
264 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
265 MISSING_PACKAGES=""
265 MISSING_PACKAGES=""
266
266
267 # Packages installed for c/c++ build environment in chroot (keep empty)
267 # Packages installed for c/c++ build environment in chroot (keep empty)
268 COMPILER_PACKAGES=""
268 COMPILER_PACKAGES=""
269
269
270 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
270 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
271 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
271 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
272 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
272 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
273 APT_PROXY=http://127.0.0.1:3142/
273 APT_PROXY=http://127.0.0.1:3142/
274 fi
274 fi
275
275
276 # Setup architecture specific settings
276 # Setup architecture specific settings
277 if [ -n "$SET_ARCH" ] ; then
277 if [ -n "$SET_ARCH" ] ; then
278 # 64-bit configuration
278 # 64-bit configuration
279 if [ "$SET_ARCH" = 64 ] ; then
279 if [ "$SET_ARCH" = 64 ] ; then
280 # General 64-bit depended settings
280 # General 64-bit depended settings
281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
282 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
282 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
284
284
285 # Raspberry Pi model specific settings
285 # Raspberry Pi model specific settings
286 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
286 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
287 if [ "$RPI_MODEL" != 4 ] ; then
287 if [ "$RPI_MODEL" != 4 ] ; then
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
289 else
289 else
290 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
290 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
291 fi
291 fi
292
292
293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
294 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
294 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
295 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
295 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
296 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
296 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
297 else
297 else
298 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
298 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
299 exit 1
299 exit 1
300 fi
300 fi
301 fi
301 fi
302
302
303 # 32-bit configuration
303 # 32-bit configuration
304 if [ "$SET_ARCH" = 32 ] ; then
304 if [ "$SET_ARCH" = 32 ] ; then
305 # General 32-bit dependend settings
305 # General 32-bit dependend settings
306 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
306 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
307 KERNEL_ARCH=${KERNEL_ARCH:=arm}
307 KERNEL_ARCH=${KERNEL_ARCH:=arm}
308 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
308 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
309
309
310 # Raspberry Pi model specific settings
310 # Raspberry Pi model specific settings
311 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
311 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
313 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
313 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
314 RELEASE_ARCH=${RELEASE_ARCH:=armel}
314 RELEASE_ARCH=${RELEASE_ARCH:=armel}
315 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
315 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
316 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
316 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
317 fi
317 fi
318
318
319 # Raspberry Pi model specific settings
319 # Raspberry Pi model specific settings
320 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
320 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
321 if [ "$RPI_MODEL" != 4 ] ; then
321 if [ "$RPI_MODEL" != 4 ] ; then
322 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
322 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
323 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
323 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
324 else
324 else
325 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
325 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
326 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
326 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
327 fi
327 fi
328
328
329 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
329 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
330 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
330 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
331 <<<<<<< HEAD
331 <<<<<<< HEAD
332 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
332 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
333 =======
333 =======
334 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
334 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
335
335
336 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
336 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
337 fi
337 fi
338 fi
338 fi
339 # SET_ARCH not set
339 # SET_ARCH not set
340 else
340 else
341 echo "error: Please set '32' or '64' as value for SET_ARCH"
341 echo "error: Please set '32' or '64' as value for SET_ARCH"
342 exit 1
342 exit 1
343 fi
343 fi
344 # Device specific configuration and U-Boot configuration
344 # Device specific configuration and U-Boot configuration
345 case "$RPI_MODEL" in
345 case "$RPI_MODEL" in
346 0)
346 0)
347 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
347 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
348 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
348 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
349 ;;
349 ;;
350 1)
350 1)
351 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
351 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
352 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
352 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
353 ;;
353 ;;
354 1P)
354 1P)
355 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
355 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
356 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
356 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
357 ;;
357 ;;
358 2)
358 2)
359 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
359 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
360 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
360 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
361 ;;
361 ;;
362 3)
362 3)
363 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
363 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
364 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
364 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
365 ;;
365 ;;
366 3P)
366 3P)
367 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
367 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
368 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
368 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
369 ;;
369 ;;
370 4)
370 4)
371 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
371 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
372 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
372 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
373 ;;
373 ;;
374 *)
374 *)
375 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
375 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
376 exit 1
376 exit 1
377 ;;
377 ;;
378 esac
378 esac
379
379
380 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
380 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
381 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
381 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
382 # Include bluetooth packages on supported boards
382 # Include bluetooth packages on supported boards
383 if [ "$ENABLE_BLUETOOTH" = true ] ; then
383 if [ "$ENABLE_BLUETOOTH" = true ] ; then
384 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
384 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
385 fi
385 fi
386 if [ "$ENABLE_WIRELESS" = true ] ; then
386 if [ "$ENABLE_WIRELESS" = true ] ; then
387 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
387 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
388 fi
388 fi
389 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
389 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
390 # Check if the internal wireless interface is not supported by the RPi model
390 # Check if the internal wireless interface is not supported by the RPi model
391 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
391 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
392 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
392 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
393 exit 1
393 exit 1
394 fi
394 fi
395 fi
395 fi
396
396
397 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
397 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
398 echo "error: You have to compile kernel sources, if you want to enable nexmon"
398 echo "error: You have to compile kernel sources, if you want to enable nexmon"
399 exit 1
399 exit 1
400 fi
400 fi
401
401
402 # Prepare date string for default image file name
402 # Prepare date string for default image file name
403 DATE="$(date +%Y-%m-%d)"
403 DATE="$(date +%Y-%m-%d)"
404 if [ -z "$KERNEL_BRANCH" ] ; then
404 if [ -z "$KERNEL_BRANCH" ] ; then
405 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
405 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
406 else
406 else
407 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
407 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
408 fi
408 fi
409
409
410 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
410 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
411 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
411 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
412 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
412 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
413 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
413 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
414 exit 1
414 exit 1
415 fi
415 fi
416 fi
416 fi
417
417
418 # Add cmake to compile videocore sources
418 # Add cmake to compile videocore sources
419 if [ "$ENABLE_VIDEOCORE" = true ] ; then
419 if [ "$ENABLE_VIDEOCORE" = true ] ; then
420 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
420 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
421 fi
421 fi
422
422
423 # Add deps for nexmon
423 # Add deps for nexmon
424 if [ "$ENABLE_NEXMON" = true ] ; then
424 if [ "$ENABLE_NEXMON" = true ] ; then
425 <<<<<<< HEAD
425 <<<<<<< HEAD
426 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
426 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
427 =======
427 =======
428 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
428 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
429 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
429 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
430 fi
430 fi
431
431
432 # Add libncurses5 to enable kernel menuconfig
432 # Add libncurses5 to enable kernel menuconfig
433 if [ "$KERNEL_MENUCONFIG" = true ] ; then
433 if [ "$KERNEL_MENUCONFIG" = true ] ; then
434 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
434 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
435 fi
435 fi
436
436
437 # Add ccache compiler cache for (faster) kernel cross (re)compilation
437 # Add ccache compiler cache for (faster) kernel cross (re)compilation
438 if [ "$KERNEL_CCACHE" = true ] ; then
438 if [ "$KERNEL_CCACHE" = true ] ; then
439 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
439 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
440 fi
440 fi
441
441
442 # Add cryptsetup package to enable filesystem encryption
442 # Add cryptsetup package to enable filesystem encryption
443 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
443 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
444 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
444 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
445 <<<<<<< HEAD
445 <<<<<<< HEAD
446 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
446 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
447 =======
447 =======
448 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
448 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
449 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
449 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
450
450
451 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
451 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
452 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
452 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
453 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
453 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
454 fi
454 fi
455
455
456 if [ -z "$CRYPTFS_PASSWORD" ] ; then
456 if [ -z "$CRYPTFS_PASSWORD" ] ; then
457 echo "error: no password defined (CRYPTFS_PASSWORD)!"
457 echo "error: no password defined (CRYPTFS_PASSWORD)!"
458 exit 1
458 exit 1
459 fi
459 fi
460 ENABLE_INITRAMFS=true
460 ENABLE_INITRAMFS=true
461 fi
461 fi
462
462
463 # Add initramfs generation tools
463 # Add initramfs generation tools
464 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
464 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
465 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
465 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
466 fi
466 fi
467
467
468 # Add device-tree-compiler required for building the U-Boot bootloader
468 # Add device-tree-compiler required for building the U-Boot bootloader
469 if [ "$ENABLE_UBOOT" = true ] ; then
469 if [ "$ENABLE_UBOOT" = true ] ; then
470 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
470 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
471 fi
471 fi
472
472
473 if [ "$ENABLE_USBBOOT" = true ] ; then
473 if [ "$ENABLE_USBBOOT" = true ] ; then
474 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
474 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
475 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
475 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
476 exit 1
476 exit 1
477 fi
477 fi
478 fi
478 fi
479
479
480 # Check if root SSH (v2) public key file exists
480 # Check if root SSH (v2) public key file exists
481 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
481 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
482 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
482 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
483 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
483 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
484 exit 1
484 exit 1
485 fi
485 fi
486 fi
486 fi
487
487
488 # Check if $USER_NAME SSH (v2) public key file exists
488 # Check if $USER_NAME SSH (v2) public key file exists
489 if [ -n "$SSH_USER_PUB_KEY" ] ; then
489 if [ -n "$SSH_USER_PUB_KEY" ] ; then
490 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
490 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
491 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
491 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
492 exit 1
492 exit 1
493 fi
493 fi
494 fi
494 fi
495
495
496 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
496 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
497 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
497 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
498 exit 1
498 exit 1
499 fi
499 fi
500
500
501 # Check if all required packages are installed on the build system
501 # Check if all required packages are installed on the build system
502 for package in $REQUIRED_PACKAGES ; do
502 for package in $REQUIRED_PACKAGES ; do
503 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
503 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
504 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
504 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
505 fi
505 fi
506 done
506 done
507
507
508 # If there are missing packages ask confirmation for install, or exit
508 # If there are missing packages ask confirmation for install, or exit
509 if [ -n "$MISSING_PACKAGES" ] ; then
509 if [ -n "$MISSING_PACKAGES" ] ; then
510 echo "the following packages needed by this script are not installed:"
510 echo "the following packages needed by this script are not installed:"
511 echo "$MISSING_PACKAGES"
511 echo "$MISSING_PACKAGES"
512
512
513 printf "\ndo you want to install the missing packages right now? [y/n] "
513 printf "\ndo you want to install the missing packages right now? [y/n] "
514 read -r confirm
514 read -r confirm
515 [ "$confirm" != "y" ] && exit 1
515 [ "$confirm" != "y" ] && exit 1
516
516
517 # Make sure all missing required packages are installed
517 # Make sure all missing required packages are installed
518 <<<<<<< HEAD
518 <<<<<<< HEAD
519 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
519 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
520 =======
520 =======
521 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
521 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
522 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
522 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
523 fi
523 fi
524
524
525 # Check if ./bootstrap.d directory exists
525 # Check if ./bootstrap.d directory exists
526 if [ ! -d "./bootstrap.d/" ] ; then
526 if [ ! -d "./bootstrap.d/" ] ; then
527 echo "error: './bootstrap.d' required directory not found!"
527 echo "error: './bootstrap.d' required directory not found!"
528 exit 1
528 exit 1
529 fi
529 fi
530
530
531 # Check if ./files directory exists
531 # Check if ./files directory exists
532 if [ ! -d "./files/" ] ; then
532 if [ ! -d "./files/" ] ; then
533 echo "error: './files' required directory not found!"
533 echo "error: './files' required directory not found!"
534 exit 1
534 exit 1
535 fi
535 fi
536
536
537 # Check if specified KERNELSRC_DIR directory exists
537 # Check if specified KERNELSRC_DIR directory exists
538 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
538 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
539 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
539 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
540 exit 1
540 exit 1
541 fi
541 fi
542
542
543 # Check if specified UBOOTSRC_DIR directory exists
543 # Check if specified UBOOTSRC_DIR directory exists
544 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
544 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
545 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
545 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
546 exit 1
546 exit 1
547 fi
547 fi
548
548
549 # Check if specified VIDEOCORESRC_DIR directory exists
549 # Check if specified VIDEOCORESRC_DIR directory exists
550 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
550 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
551 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
551 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
552 exit 1
552 exit 1
553 fi
553 fi
554
554
555 # Check if specified FBTURBOSRC_DIR directory exists
555 # Check if specified FBTURBOSRC_DIR directory exists
556 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
556 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
557 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
557 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
558 exit 1
558 exit 1
559 fi
559 fi
560
560
561 # Check if specified NEXMONSRC_DIR directory exists
561 # Check if specified NEXMONSRC_DIR directory exists
562 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
562 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
563 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
563 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
564 exit 1
564 exit 1
565 fi
565 fi
566
566
567 # Check if specified CHROOT_SCRIPTS directory exists
567 # Check if specified CHROOT_SCRIPTS directory exists
568 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
568 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
569 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
569 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
570 exit 1
570 exit 1
571 fi
571 fi
572
572
573 # Check if specified device mapping already exists (will be used by cryptsetup)
573 # Check if specified device mapping already exists (will be used by cryptsetup)
574 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
574 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
575 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
575 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
576 exit 1
576 exit 1
577 fi
577 fi
578
578
579 # Don't clobber an old build
579 # Don't clobber an old build
580 if [ -e "$BUILDDIR" ] ; then
580 if [ -e "$BUILDDIR" ] ; then
581 echo "error: directory ${BUILDDIR} already exists, not proceeding"
581 echo "error: directory ${BUILDDIR} already exists, not proceeding"
582 exit 1
582 exit 1
583 fi
583 fi
584
584
585 # Setup chroot directory
585 # Setup chroot directory
586 mkdir -p "${R}"
586 mkdir -p "${R}"
587
587
588 # Check if build directory has enough of free disk space >512MB
588 # Check if build directory has enough of free disk space >512MB
589 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
589 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
590 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
590 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
591 exit 1
591 exit 1
592 fi
592 fi
593
593
594 set -x
594 set -x
595
595
596 # Call "cleanup" function on various signals and errors
596 # Call "cleanup" function on various signals and errors
597 trap cleanup 0 1 2 3 6
597 trap cleanup 0 1 2 3 6
598
598
599 # Add required packages for the minbase installation
599 # Add required packages for the minbase installation
600 if [ "$ENABLE_MINBASE" = true ] ; then
600 if [ "$ENABLE_MINBASE" = true ] ; then
601 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
601 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
602 fi
602 fi
603
603
604 # Add parted package, required to get partprobe utility
604 # Add parted package, required to get partprobe utility
605 if [ "$EXPANDROOT" = true ] ; then
605 if [ "$EXPANDROOT" = true ] ; then
606 APT_INCLUDES="${APT_INCLUDES},parted"
606 APT_INCLUDES="${APT_INCLUDES},parted"
607 fi
607 fi
608
608
609 # Add dphys-swapfile package, required to enable swap
609 # Add dphys-swapfile package, required to enable swap
610 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
610 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
611 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
611 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
612 fi
612 fi
613
613
614 # Add dbus package, recommended if using systemd
614 # Add dbus package, recommended if using systemd
615 if [ "$ENABLE_DBUS" = true ] ; then
615 if [ "$ENABLE_DBUS" = true ] ; then
616 APT_INCLUDES="${APT_INCLUDES},dbus"
616 APT_INCLUDES="${APT_INCLUDES},dbus"
617 fi
617 fi
618
618
619 # Add iptables IPv4/IPv6 package
619 # Add iptables IPv4/IPv6 package
620 if [ "$ENABLE_IPTABLES" = true ] ; then
620 if [ "$ENABLE_IPTABLES" = true ] ; then
621 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
621 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
622 fi
622 fi
623 # Add apparmor for KERNEL_SECURITY
623 # Add apparmor for KERNEL_SECURITY
624 if [ "$KERNEL_SECURITY" = true ] ; then
624 if [ "$KERNEL_SECURITY" = true ] ; then
625 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
625 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
626 fi
626 fi
627
627
628 # Add openssh server package
628 # Add openssh server package
629 if [ "$ENABLE_SSHD" = true ] ; then
629 if [ "$ENABLE_SSHD" = true ] ; then
630 APT_INCLUDES="${APT_INCLUDES},openssh-server"
630 APT_INCLUDES="${APT_INCLUDES},openssh-server"
631 fi
631 fi
632
632
633 # Add alsa-utils package
633 # Add alsa-utils package
634 if [ "$ENABLE_SOUND" = true ] ; then
634 if [ "$ENABLE_SOUND" = true ] ; then
635 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
635 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
636 fi
636 fi
637
637
638 # Add rng-tools package
638 # Add rng-tools package
639 if [ "$ENABLE_HWRANDOM" = true ] ; then
639 if [ "$ENABLE_HWRANDOM" = true ] ; then
640 APT_INCLUDES="${APT_INCLUDES},rng-tools"
640 APT_INCLUDES="${APT_INCLUDES},rng-tools"
641 fi
641 fi
642
642
643 # Add fbturbo video driver
643 # Add fbturbo video driver
644 if [ "$ENABLE_FBTURBO" = true ] ; then
644 if [ "$ENABLE_FBTURBO" = true ] ; then
645 # Enable xorg package dependencies
645 # Enable xorg package dependencies
646 ENABLE_XORG=true
646 ENABLE_XORG=true
647 fi
647 fi
648
648
649 # Add user defined window manager package
649 # Add user defined window manager package
650 if [ -n "$ENABLE_WM" ] ; then
650 if [ -n "$ENABLE_WM" ] ; then
651 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
651 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
652
652
653 # Enable xorg package dependencies
653 # Enable xorg package dependencies
654 ENABLE_XORG=true
654 ENABLE_XORG=true
655 fi
655 fi
656
656
657 # Add xorg package
657 # Add xorg package
658 if [ "$ENABLE_XORG" = true ] ; then
658 if [ "$ENABLE_XORG" = true ] ; then
659 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
659 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
660 fi
660 fi
661
661
662 # Replace selected packages with smaller clones
662 # Replace selected packages with smaller clones
663 if [ "$ENABLE_REDUCE" = true ] ; then
663 if [ "$ENABLE_REDUCE" = true ] ; then
664 # Add levee package instead of vim-tiny
664 # Add levee package instead of vim-tiny
665 if [ "$REDUCE_VIM" = true ] ; then
665 if [ "$REDUCE_VIM" = true ] ; then
666 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
666 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
667 fi
667 fi
668
668
669 # Add dropbear package instead of openssh-server
669 # Add dropbear package instead of openssh-server
670 if [ "$REDUCE_SSHD" = true ] ; then
670 if [ "$REDUCE_SSHD" = true ] ; then
671 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
671 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
672 fi
672 fi
673 fi
673 fi
674
674
675 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
675 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
676 if [ "$ENABLE_SYSVINIT" = false ] ; then
676 if [ "$ENABLE_SYSVINIT" = false ] ; then
677 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
677 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
678 fi
678 fi
679
679
680 # Configure kernel sources if no KERNELSRC_DIR
680 # Configure kernel sources if no KERNELSRC_DIR
681 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
681 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
682 KERNELSRC_CONFIG=true
682 KERNELSRC_CONFIG=true
683 fi
683 fi
684
684
685 # Configure reduced kernel
685 # Configure reduced kernel
686 if [ "$KERNEL_REDUCE" = true ] ; then
686 if [ "$KERNEL_REDUCE" = true ] ; then
687 KERNELSRC_CONFIG=false
687 KERNELSRC_CONFIG=false
688 fi
688 fi
689
689
690 # Configure qemu compatible kernel
690 # Configure qemu compatible kernel
691 if [ "$ENABLE_QEMU" = true ] ; then
691 if [ "$ENABLE_QEMU" = true ] ; then
692 DTB_FILE=vexpress-v2p-ca15_a7.dtb
692 DTB_FILE=vexpress-v2p-ca15_a7.dtb
693 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
693 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
694 KERNEL_DEFCONFIG="vexpress_defconfig"
694 KERNEL_DEFCONFIG="vexpress_defconfig"
695 if [ "$KERNEL_MENUCONFIG" = false ] ; then
695 if [ "$KERNEL_MENUCONFIG" = false ] ; then
696 KERNEL_OLDDEFCONFIG=true
696 KERNEL_OLDDEFCONFIG=true
697 fi
697 fi
698 fi
698 fi
699
699
700 # Execute bootstrap scripts
700 # Execute bootstrap scripts
701 for SCRIPT in bootstrap.d/*.sh; do
701 for SCRIPT in bootstrap.d/*.sh; do
702 head -n 3 "$SCRIPT"
702 head -n 3 "$SCRIPT"
703 . "$SCRIPT"
703 . "$SCRIPT"
704 done
704 done
705
705
706 ## Execute custom bootstrap scripts
706 ## Execute custom bootstrap scripts
707 if [ -d "custom.d" ] ; then
707 if [ -d "custom.d" ] ; then
708 for SCRIPT in custom.d/*.sh; do
708 for SCRIPT in custom.d/*.sh; do
709 . "$SCRIPT"
709 . "$SCRIPT"
710 done
710 done
711 fi
711 fi
712
712
713 # Execute custom scripts inside the chroot
713 # Execute custom scripts inside the chroot
714 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
714 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
715 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
715 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
716 chroot_exec /bin/bash -x <<'EOF'
716 chroot_exec /bin/bash -x <<'EOF'
717 for SCRIPT in /chroot_scripts/* ; do
717 for SCRIPT in /chroot_scripts/* ; do
718 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
718 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
719 $SCRIPT
719 $SCRIPT
720 fi
720 fi
721 done
721 done
722 EOF
722 EOF
723 rm -rf "${R}/chroot_scripts"
723 rm -rf "${R}/chroot_scripts"
724 fi
724 fi
725
725
726 # Remove c/c++ build environment from the chroot
726 # Remove c/c++ build environment from the chroot
727 chroot_remove_cc
727 chroot_remove_cc
728
728
729 # Generate required machine-id
729 # Generate required machine-id
730 MACHINE_ID=$(dbus-uuidgen)
730 MACHINE_ID=$(dbus-uuidgen)
731 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
731 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
732 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
732 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
733
733
734 # APT Cleanup
734 # APT Cleanup
735 chroot_exec apt-get -y clean
735 chroot_exec apt-get -y clean
736 chroot_exec apt-get -y autoclean
736 chroot_exec apt-get -y autoclean
737 chroot_exec apt-get -y autoremove
737 chroot_exec apt-get -y autoremove
738
738
739 # Unmount mounted filesystems
739 # Unmount mounted filesystems
740 umount -l "${R}/proc"
740 umount -l "${R}/proc"
741 umount -l "${R}/sys"
741 umount -l "${R}/sys"
742
742
743 # Clean up directories
743 # Clean up directories
744 rm -rf "${R}/run/*"
744 rm -rf "${R}/run/*"
745 rm -rf "${R}/tmp/*"
745 rm -rf "${R}/tmp/*"
746
746
747 # Clean up APT proxy settings
747 # Clean up APT proxy settings
748 if [ "$KEEP_APT_PROXY" = false ] ; then
748 if [ "$KEEP_APT_PROXY" = false ] ; then
749 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
749 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
750 fi
750 fi
751
751
752 # Clean up files
752 # Clean up files
753 rm -f "${ETC_DIR}/ssh/ssh_host_*"
753 rm -f "${ETC_DIR}/ssh/ssh_host_*"
754 rm -f "${ETC_DIR}/dropbear/dropbear_*"
754 rm -f "${ETC_DIR}/dropbear/dropbear_*"
755 rm -f "${ETC_DIR}/apt/sources.list.save"
755 rm -f "${ETC_DIR}/apt/sources.list.save"
756 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
756 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
757 rm -f "${ETC_DIR}/*-"
757 rm -f "${ETC_DIR}/*-"
758 rm -f "${ETC_DIR}/resolv.conf"
758 rm -f "${ETC_DIR}/resolv.conf"
759 rm -f "${R}/root/.bash_history"
759 rm -f "${R}/root/.bash_history"
760 rm -f "${R}/var/lib/urandom/random-seed"
760 rm -f "${R}/var/lib/urandom/random-seed"
761 rm -f "${R}/initrd.img"
761 rm -f "${R}/initrd.img"
762 rm -f "${R}/vmlinuz"
762 rm -f "${R}/vmlinuz"
763 rm -f "${R}${QEMU_BINARY}"
763 rm -f "${R}${QEMU_BINARY}"
764
764
765 if [ "$ENABLE_QEMU" = true ] ; then
765 if [ "$ENABLE_QEMU" = true ] ; then
766 # Setup QEMU directory
766 # Setup QEMU directory
767 mkdir "${BASEDIR}/qemu"
767 mkdir "${BASEDIR}/qemu"
768
768
769 # Copy kernel image to QEMU directory
769 # Copy kernel image to QEMU directory
770 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
770 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
771
771
772 # Copy kernel config to QEMU directory
772 # Copy kernel config to QEMU directory
773 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
773 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
774
774
775 # Copy kernel dtbs to QEMU directory
775 # Copy kernel dtbs to QEMU directory
776 for dtb in "${BOOT_DIR}/"*.dtb ; do
776 for dtb in "${BOOT_DIR}/"*.dtb ; do
777 if [ -f "${dtb}" ] ; then
777 if [ -f "${dtb}" ] ; then
778 install_readonly "${dtb}" "${BASEDIR}/qemu/"
778 install_readonly "${dtb}" "${BASEDIR}/qemu/"
779 fi
779 fi
780 done
780 done
781
781
782 # Copy kernel overlays to QEMU directory
782 # Copy kernel overlays to QEMU directory
783 if [ -d "${BOOT_DIR}/overlays" ] ; then
783 if [ -d "${BOOT_DIR}/overlays" ] ; then
784 # Setup overlays dtbs directory
784 # Setup overlays dtbs directory
785 mkdir "${BASEDIR}/qemu/overlays"
785 mkdir "${BASEDIR}/qemu/overlays"
786
786
787 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
787 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
788 if [ -f "${dtb}" ] ; then
788 if [ -f "${dtb}" ] ; then
789 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
789 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
790 fi
790 fi
791 done
791 done
792 fi
792 fi
793
793
794 # Copy u-boot files to QEMU directory
794 # Copy u-boot files to QEMU directory
795 if [ "$ENABLE_UBOOT" = true ] ; then
795 if [ "$ENABLE_UBOOT" = true ] ; then
796 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
796 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
797 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
797 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
798 fi
798 fi
799 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
799 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
800 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
800 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
801 fi
801 fi
802 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
802 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
803 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
803 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
804 fi
804 fi
805 fi
805 fi
806
806
807 # Copy initramfs to QEMU directory
807 # Copy initramfs to QEMU directory
808 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
808 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
809 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
809 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
810 fi
810 fi
811 fi
811 fi
812
812
813 # Calculate size of the chroot directory in KB
813 # Calculate size of the chroot directory in KB
814 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
814 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
815
815
816 # Calculate the amount of needed 512 Byte sectors
816 # Calculate the amount of needed 512 Byte sectors
817 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
817 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
818 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
818 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
819 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
819 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
820
820
821 # The root partition is EXT4
821 # The root partition is EXT4
822 # This means more space than the actual used space of the chroot is used.
822 # This means more space than the actual used space of the chroot is used.
823 # As overhead for journaling and reserved blocks 35% are added.
823 # As overhead for journaling and reserved blocks 35% are added.
824 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
824 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
825
825
826 # Calculate required image size in 512 Byte sectors
826 # Calculate required image size in 512 Byte sectors
827 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
827 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
828
828
829 # Prepare image file
829 # Prepare image file
830 if [ "$ENABLE_SPLITFS" = true ] ; then
830 if [ "$ENABLE_SPLITFS" = true ] ; then
831 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
831 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
832 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
832 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
833 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
833 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
834 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
834 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
835
835
836 # Write firmware/boot partition tables
836 # Write firmware/boot partition tables
837 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
837 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
838 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
838 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
839 EOM
839 EOM
840
840
841 # Write root partition table
841 # Write root partition table
842 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
842 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
843 ${TABLE_SECTORS},${ROOT_SECTORS},83
843 ${TABLE_SECTORS},${ROOT_SECTORS},83
844 EOM
844 EOM
845
845
846 # Setup temporary loop devices
846 # Setup temporary loop devices
847 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
847 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
848 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
848 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
849 else # ENABLE_SPLITFS=false
849 else # ENABLE_SPLITFS=false
850 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
850 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
851 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
851 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
852
852
853 # Write partition table
853 # Write partition table
854 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
854 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
855 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
855 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
856 ${ROOT_OFFSET},${ROOT_SECTORS},83
856 ${ROOT_OFFSET},${ROOT_SECTORS},83
857 EOM
857 EOM
858
858
859 # Setup temporary loop devices
859 # Setup temporary loop devices
860 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
860 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
861 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
861 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
862 fi
862 fi
863
863
864 if [ "$ENABLE_CRYPTFS" = true ] ; then
864 if [ "$ENABLE_CRYPTFS" = true ] ; then
865 # Create dummy ext4 fs
865 # Create dummy ext4 fs
866 mkfs.ext4 "$ROOT_LOOP"
866 mkfs.ext4 "$ROOT_LOOP"
867
867
868 # Setup password keyfile
868 # Setup password keyfile
869 touch .password
869 touch .password
870 chmod 600 .password
870 chmod 600 .password
871 echo -n ${CRYPTFS_PASSWORD} > .password
871 echo -n ${CRYPTFS_PASSWORD} > .password
872
872
873 # Initialize encrypted partition
873 # Initialize encrypted partition
874 <<<<<<< HEAD
874 <<<<<<< HEAD
875 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
875 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
876 =======
876 =======
877 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
877 >>>>>>> af203dbe173e4e5ca755058b3284dc61375ca579
878 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
878 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
879
879
880 # Open encrypted partition and setup mapping
880 # Open encrypted partition and setup mapping
881 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
881 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
882
882
883 # Secure delete password keyfile
883 # Secure delete password keyfile
884 shred -zu .password
884 shred -zu .password
885
885
886 # Update temporary loop device
886 # Update temporary loop device
887 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
887 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
888
888
889 # Wipe encrypted partition (encryption cipher is used for randomness)
889 # Wipe encrypted partition (encryption cipher is used for randomness)
890 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
890 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
891 fi
891 fi
892
892
893 # Build filesystems
893 # Build filesystems
894 mkfs.vfat "$FRMW_LOOP"
894 mkfs.vfat "$FRMW_LOOP"
895 mkfs.ext4 "$ROOT_LOOP"
895 mkfs.ext4 "$ROOT_LOOP"
896
896
897 # Mount the temporary loop devices
897 # Mount the temporary loop devices
898 mkdir -p "$BUILDDIR/mount"
898 mkdir -p "$BUILDDIR/mount"
899 mount "$ROOT_LOOP" "$BUILDDIR/mount"
899 mount "$ROOT_LOOP" "$BUILDDIR/mount"
900
900
901 mkdir -p "$BUILDDIR/mount/boot/firmware"
901 mkdir -p "$BUILDDIR/mount/boot/firmware"
902 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
902 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
903
903
904 # Copy all files from the chroot to the loop device mount point directory
904 # Copy all files from the chroot to the loop device mount point directory
905 rsync -a "${R}/" "$BUILDDIR/mount/"
905 rsync -a "${R}/" "$BUILDDIR/mount/"
906
906
907 # Unmount all temporary loop devices and mount points
907 # Unmount all temporary loop devices and mount points
908 cleanup
908 cleanup
909
909
910 # Create block map file(s) of image(s)
910 # Create block map file(s) of image(s)
911 if [ "$ENABLE_SPLITFS" = true ] ; then
911 if [ "$ENABLE_SPLITFS" = true ] ; then
912 # Create block map files for "bmaptool"
912 # Create block map files for "bmaptool"
913 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
913 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
914 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
914 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
915
915
916 # Image was successfully created
916 # Image was successfully created
917 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
917 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
918 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
918 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
919 else
919 else
920 # Create block map file for "bmaptool"
920 # Create block map file for "bmaptool"
921 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
921 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
922
922
923 # Image was successfully created
923 # Image was successfully created
924 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
924 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
925
925
926 # Create qemu qcow2 image
926 # Create qemu qcow2 image
927 if [ "$ENABLE_QEMU" = true ] ; then
927 if [ "$ENABLE_QEMU" = true ] ; then
928 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
928 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
929 QEMU_SIZE=16G
929 QEMU_SIZE=16G
930
930
931 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
931 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
932 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
932 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
933
933
934 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
934 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
935 fi
935 fi
936 fi
936 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant